/**
 * 
 */
package de.msponer.android.yac.activities.workqueues.listener;

import android.view.View;
import android.view.View.OnClickListener;
import android.widget.LinearLayout;
import de.msponer.android.yac.xml.WorkItemElementEntry;

/**
 * Onclicklistener to remove work item element entries from a father panel.
 * 
 * @author msponer
 * 
 */
public class RemoveWorkItemElementEntryListener implements OnClickListener {

	/**
	 * The father panel.
	 */
	private LinearLayout mFatherPanel;

	/**
	 * The child panel.
	 */
	private LinearLayout mChildpanel;

	/**
	 * The work item element entry to remove.
	 */
	private WorkItemElementEntry mWorkItemElementEntry;

	/**
	 * Constructor setting the required attributes.
	 * 
	 * @param workItemElementEntry
	 *            The work item element entry to remove.
	 * @param fatherPanel
	 *            The father panel.
	 * @param childPanel
	 *            The child panel.
	 */
	public RemoveWorkItemElementEntryListener(WorkItemElementEntry workItemElementEntry,
			LinearLayout fatherPanel, LinearLayout childPanel) {
		super();
		this.mFatherPanel = fatherPanel;
		this.mChildpanel = childPanel;
		this.mWorkItemElementEntry = workItemElementEntry;
	}

	/**
	 * {@inheritDoc}
	 * Removes the child from the father panel and deletes the specified work
	 * item element entry.
	 */
	@Override
	public void onClick(View arg0) {
		this.mFatherPanel.removeView(mChildpanel);
		mWorkItemElementEntry.getParent().getSubElementEntryList().remove(mWorkItemElementEntry);
	}

}
