/**
 * 
 */
package de.msponer.android.yac.util;

import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * Class for decoding QR-Code scan results.
 * 
 * @author msponer
 * 
 */
public class QRCodeDecoder {

	/**
	 * Constructor.
	 */
	protected QRCodeDecoder() {
		
	}
	
	/**
	 * Takes a QR-Code scan result string, processes it and returns a map that
	 * exists of resulting key-value pairs.
	 * 
	 * @param scanResults The QR code scan result string.
	 * @return The resulting K-V pair map.
	 */
	public static Map<String, String> getResultsMap(String scanResults) {

		StringTokenizer tokenizer = new StringTokenizer(scanResults, ";");

		Map<String, String> scanResultMap = new HashMap<String, String>();

		while (tokenizer.hasMoreTokens()) {
			String tokenString = (String) tokenizer.nextToken();

			StringTokenizer tokenTokenizer = new StringTokenizer(tokenString, ":");

			String key = "", value = "";

			if (tokenTokenizer.countTokens() == 3) {
				tokenTokenizer.nextToken();
			}
			
			if(tokenTokenizer.hasMoreTokens()) {
				key = tokenTokenizer.nextToken();
			}
			
			if(tokenTokenizer.hasMoreTokens()) {
				value = tokenTokenizer.nextToken();
			}
			
			// Log.d(TAG, key+":"+value);
			scanResultMap.put(key, value);
		}

		return scanResultMap;
	}
}
